@echo off

if not defined DXC_HOME (
  echo Setting DXC_HOME to %CD%
  set DXC_HOME=%CD%
)

set JAVA_TESTS_VAL=false

set TMPPATH=%DXC_HOME%\Bin
set CONTAINED=false

for %%P in (%PATH%) do (
  if "%%P"=="%TMPPATH%" ( 
    set CONTAINED=true 
  )
)
  
if not %CONTAINED%==true (
  set PATH=%PATH%;%TMPPATH%
)

if not defined JAVA_HOME (
  if not "%1"=="nojava" (
    echo Setting JAVA_HOME to %1
    set JAVA_HOME=%1
    set JAVA_TESTS_VAL=true
  )
) else (
  set JAVA_TESTS_VAL=true
)

cmake -DRUN_DOXYGEN=true -DBUILD_CPP_TESTS=true -DBUILD_JAVA_TESTS=%JAVA_TESTS_VAL% .
if %ERRORLEVEL% NEQ 0 goto BUILD_ERROR

VCExpress "DXC.sln" /build Debug /project INSTALL /out tmp.txt
set BUILDERROR=%ERRORLEVEL%
type tmp.txt
del tmp.txt
if %BUILDERROR% NEQ 0 goto BUILD_ERROR

if not "%1"=="nojava" (
  pushd Src
  call ant install
  if %ERRORLEVEL% NEQ 0 (
    echo command \`ant install\':
    echo buildAndTest:0: warning: Java build failed
    if defined JAVA_HOME (
      echo Make sure JAVA_HOME points to a working JSDK
      goto BUILD_ERROR
    )
  )
  popd
)

echo.
echo Running Cpp tests
"%DXC_HOME%\Bin\TestRunner"
if %ERRORLEVEL% NEQ 0 goto BUILD_ERROR

echo.

if not "%1"=="nojava" (
  echo Running Java tests
  pushd Src
  call ant runTests
  popd
  if %ERRORLEVEL% NEQ 0 (
    echo command \`ant runTests\':
    echo buildAndTest:0: warning: Java tests failed
    if defined JAVA_HOME (
      echo Make sure JAVA_HOME points to a working JSDK
      goto BUILD_ERROR
    )
  )
)
goto EOF

:BUILD_ERROR
echo buildAndTest:0: error: Build failed!

:EOF
