/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_EXCEPTION
#define DXC_EXCEPTION

#include <exception>
#include <string>

#include <DxcDefs.hpp>

namespace Dxc
{
/**
 * @brief Exceptions thrown by Dxc API
 */
class DXCAPI_EXPORT DxcException
{
public:
    DxcException(const char *);
    DxcException(const std::string &);

public:
    virtual char const *what();

private:
    std::string errorMessage_;
};

}

#endif
