package org.dxc.evaluator.metrics;

/*
 * CPU Time metric.
 */
public class FalseNegatives implements DAMetricCalculator {
    private int totalFaulty = -1;
    private int falseNegatives = -1;
    private double fnr = Double.NaN;
    private int minPoints = -1;

    public void addSMCalculator(ScenarioMetricCalculator smc) {
        Detection d = (Detection) smc;
        if (d == null)
            return;

        if (totalFaulty < 0
                && !d.getDetection().equals(Detection.DetectionType.UNDEFINED)) {
            totalFaulty = 0;
            falseNegatives = 0;
        }

        if (d.isFaultScenario())
            totalFaulty++;

        if (d.getDetection().equals(Detection.DetectionType.FALSE_NEGATIVE)) {
            falseNegatives++;
        }
    }

    public void calculate() {
        if (totalFaulty == 0)
            fnr = 0;
        else
            fnr = falseNegatives / (double) totalFaulty;
    }

    public double getScore() {
        if (totalFaulty >= minPoints)
            return fnr;
        else
            return Double.NaN;
    }

    public void setMinDataPoints(int min) {
        minPoints = min;
    }

    public void print() {
        System.out.println("False Negatives Rate: " + fnr);
    }
}